"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rstar_wasm_1 = require("./pkg/rstar_wasm");
class RTree {
    constructor() {
        this.uid = Math.random().toString();
        rstar_wasm_1.create_tree(this.uid);
    }
    insert(point) {
        rstar_wasm_1.insert_to_tree(this.uid, this.wasmPoint(point));
    }
    nearest(point) {
        const wasmPoint = rstar_wasm_1.nearest_in_tree(this.uid, this.wasmPoint(point));
        if (wasmPoint.length) {
            return [wasmPoint[0], wasmPoint[1]];
        }
        return [];
    }
    destroy() {
        rstar_wasm_1.remove_from_tree(this.uid);
    }
    wasmPoint(point) {
        let wasmPoint = new Float64Array(2);
        wasmPoint[0] = point[0];
        wasmPoint[1] = point[1];
        return wasmPoint;
    }
}
exports.RTree = RTree;
