let wasm;

let WASM_VECTOR_LEN = 0;

let cachegetNodeBufferMemory = null;
function getNodeBufferMemory() {
    if (cachegetNodeBufferMemory === null || cachegetNodeBufferMemory.buffer !== wasm.memory.buffer) {
        cachegetNodeBufferMemory = Buffer.from(wasm.memory.buffer);
    }
    return cachegetNodeBufferMemory;
}

function passStringToWasm(arg) {

    const len = Buffer.byteLength(arg);
    const ptr = wasm.__wbindgen_malloc(len);
    getNodeBufferMemory().write(arg, ptr, len);
    WASM_VECTOR_LEN = len;
    return ptr;
}
/**
* @param {string} uid
*/
module.exports.create_tree = function(uid) {
    wasm.create_tree(passStringToWasm(uid), WASM_VECTOR_LEN);
};

let cachegetFloat64Memory = null;
function getFloat64Memory() {
    if (cachegetFloat64Memory === null || cachegetFloat64Memory.buffer !== wasm.memory.buffer) {
        cachegetFloat64Memory = new Float64Array(wasm.memory.buffer);
    }
    return cachegetFloat64Memory;
}

function passArrayF64ToWasm(arg) {
    const ptr = wasm.__wbindgen_malloc(arg.length * 8);
    getFloat64Memory().set(arg, ptr / 8);
    WASM_VECTOR_LEN = arg.length;
    return ptr;
}
/**
* @param {string} uid
* @param {Float64Array} point
*/
module.exports.insert_to_tree = function(uid, point) {
    wasm.insert_to_tree(passStringToWasm(uid), WASM_VECTOR_LEN, passArrayF64ToWasm(point), WASM_VECTOR_LEN);
};

/**
* @param {string} uid
*/
module.exports.remove_from_tree = function(uid) {
    wasm.remove_from_tree(passStringToWasm(uid), WASM_VECTOR_LEN);
};

let cachegetInt32Memory = null;
function getInt32Memory() {
    if (cachegetInt32Memory === null || cachegetInt32Memory.buffer !== wasm.memory.buffer) {
        cachegetInt32Memory = new Int32Array(wasm.memory.buffer);
    }
    return cachegetInt32Memory;
}

function getArrayF64FromWasm(ptr, len) {
    return getFloat64Memory().subarray(ptr / 8, ptr / 8 + len);
}
/**
* @param {string} uid
* @param {Float64Array} point
* @returns {Float64Array}
*/
module.exports.nearest_in_tree = function(uid, point) {
    const retptr = 8;
    const ret = wasm.nearest_in_tree(retptr, passStringToWasm(uid), WASM_VECTOR_LEN, passArrayF64ToWasm(point), WASM_VECTOR_LEN);
    const memi32 = getInt32Memory();
    const v0 = getArrayF64FromWasm(memi32[retptr / 4 + 0], memi32[retptr / 4 + 1]).slice();
    wasm.__wbindgen_free(memi32[retptr / 4 + 0], memi32[retptr / 4 + 1] * 8);
    return v0;
};

wasm = require('./rstar_wasm_bg');

